package me.unurled.raxen.listener.entity;

import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.entity.other.EntityNamespacedKey;
import me.unurled.raxen.manager.entity.PlayerManager;
import org.bukkit.Bukkit;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByBlockEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import static me.unurled.raxen.utils.Utils.debug;

public class DamageEntity implements Listener {

    private Raxen main;
    private EntityNamespacedKey entityNamespacedKey;

    public DamageEntity(Raxen main) {
        this.main = main;
        this.entityNamespacedKey = new EntityNamespacedKey(main);
    }

    /**
     * fired when an entity is damaged by another entity
     * calculates the damage and apply it to the entity
     * @param e
     */
    @EventHandler
    public void entityDamageByEntity(EntityDamageByEntityEvent e) {
        if (!(e.getEntity() instanceof LivingEntity) || !(e.getDamager() instanceof LivingEntity)) {
            debug("Not Living Entity, Some block falling shit or block entities");
        } else {
            e.setDamage(0);
            Integer damage = 1;
            Integer strength = 0;
            Integer itemStrength = 0;
            Integer defense = 0;
            Integer itemDefense = 0;
            Integer health = 0;
            Integer itemHealth = 0;
            Integer initDamage = 0;
            PlayerManager pm = ((Raxen) Bukkit.getPluginManager().getPlugin("Raxen")).getManager().getPlayerManager();
            debug(main, e.getEntity().getName(), e.getEntity().getType().toString(), e.getDamager().getType().toString(), e.getDamager().getName());
            if (e.getDamager() instanceof Player) {
                Player playerDamager = (Player) e.getDamager();
                strength = pm.getStrength().get(playerDamager);
                itemStrength = pm.getItemStrength().get(playerDamager);
            } else {
                Entity entityDamager = e.getDamager();
                PersistentDataContainer data = entityDamager.getPersistentDataContainer();
                if (data.has(entityNamespacedKey.strength, PersistentDataType.INTEGER)) {
                    strength = data.get(entityNamespacedKey.strength, PersistentDataType.INTEGER);
                }
                itemStrength = pm.getItemStrength().getItem((LivingEntity) entityDamager);
            }
            if (e.getEntity() instanceof Player) {
                Player playerVictim = (Player) e.getEntity();
                me.unurled.raxen.components.entity.player.attributes.Attributes attributes = new me.unurled.raxen.components.entity.player.attributes.Attributes(main);
                defense = pm.getDefense().get(playerVictim);
                health = pm.getHealth().get(playerVictim);
                itemDefense = pm.getItemDefense().get(playerVictim);
                itemHealth = pm.getItemHealth().get(playerVictim);
            } else {
                Entity entityVictim = e.getEntity();
                PersistentDataContainer data = entityVictim.getPersistentDataContainer();
                if (data.has(entityNamespacedKey.defense, PersistentDataType.INTEGER)) {
                    defense = data.get(entityNamespacedKey.defense, PersistentDataType.INTEGER);
                }
                if (data.has(entityNamespacedKey.health, PersistentDataType.INTEGER)) {
                    health = data.get(entityNamespacedKey.health, PersistentDataType.INTEGER);
                }
                itemDefense = pm.getItemDefense().getItem((LivingEntity) entityVictim);
                itemHealth = pm.getItemHealth().getItem((LivingEntity) entityVictim);
            }
            debug(main, initDamage.toString(), itemDefense.toString(), strength.toString());
            initDamage = (5+ itemStrength) * (1+ (strength/100));
            damage = initDamage;
            defense = defense + itemDefense;
            debug(main, String.valueOf(damage));
            defense = defense/(defense+100);
            debug(main, String.valueOf(damage));
            debug(main, String.valueOf(defense));
            Integer health_with_defense = health * (1+ (defense/100));
            debug(main, String.valueOf(damage));
            debug(main, String.valueOf(health));
            debug(main, String.valueOf(health_with_defense));
            if (damage >= health_with_defense) {
                debug(main, "Killed entity normally.");
                e.setDamage(e.getEntity().getType().getDefaultAttributes().getAttribute(Attribute.GENERIC_MAX_HEALTH).getDefaultValue());
            } else {
                debug(main, "Applying damage to entity.");
                if (defense == 0) {
                    health = health_with_defense - damage;
                } else {
                    health = health_with_defense - health - damage;
                }
                if (e.getEntity() instanceof Player) {
                    Player playerVictim = (Player) e.getEntity();
                    me.unurled.raxen.components.entity.player.attributes.Attributes attributes = new me.unurled.raxen.components.entity.player.attributes.Attributes(main);
                    pm.getHealth().set(playerVictim, health);
                    playerVictim.setHealth(health.doubleValue()/5);
                } else {
                    Entity entityVictim = e.getEntity();
                    pm.getHealth().set(entityVictim, health);
                }
                debug(main, health.toString());
            }
        }
    }

    /**
     * damage made by blocks on entity
     * @param e
     */
    @EventHandler
    public void entityDamageByBlock(EntityDamageByBlockEvent e) {
        e.setDamage(0);
        if (e.getEntity() instanceof Player) {
            Player player = (Player) e.getEntity();


        }
    }
}
