package me.unurled.raxen.utils.libs;

import lombok.Getter;
import me.unurled.raxen.Raxen;
import net.milkbowl.vault.economy.Economy;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.RegisteredServiceProvider;

import java.text.DecimalFormat;

import static me.unurled.raxen.utils.Utils.error;

public class Vault {
    @Getter
    private Economy econ = null;
    //econ.depositPlayer(player,amount)
    //econ.withdrawPlayer(player,amount)
    //econ.getBalance(player);


    private static Raxen main;

    public Vault(Raxen main) {
        this.main = main;
        setupEconomy();
    }

    private void setupEconomy() {
        if (main.getServer().getPluginManager().getPlugin("Vault") == null) {
            error((Raxen) Bukkit.getPluginManager().getPlugin("Raxen"),"Need to install plugin Vault. (https://github.com/milkbowl/Vault)");
            return;
        }
        RegisteredServiceProvider<Economy> rsp = main.getServer().getServicesManager().getRegistration(Economy.class);
        if (rsp == null) {
            error((Raxen) Bukkit.getPluginManager().getPlugin("Raxen"),"Some bug happend in the initialisation of Vault and Raxen.");
            return;
        }
        econ = rsp.getProvider();
        return;
    }

    public String getBalanceString(Player player) {
        double bal = econ.getBalance(player);
        DecimalFormat format = new DecimalFormat("#,###.00");
        return format.format(bal);
    }
}
